
#define	_CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include "FileInfo.h"

#define		ON				0	
#define		OFF				1	
#define		MAX_NUM			3	//	ڹ迭 

#define		YES				1	
#define		NO				-1	
#define		NINE			9	

/*	޴ ִ Լ	*/
void MENU(void);

/*	κ ޴  ޴ Լ	*/
void User_Selection_Menu(int* pUser);

/*	ߺ  ʰ, 迭  ڸ ϴ Լ		*/
void Generate_RandomNumber(int* pRandom);

/*	 迭 ڸ ϴ Լ	*/
void ShowArrayNumber(int* pArray);

/*	ߺ  ʰ, 迭 ڸ κ Է¹޾ ϴ Լ		*/
void Player_Input_Number(int* pPlayer_Num);

/*	  Լ	*/
void Play_Game(int* pPlayer_Num, int* pRandom);

/*	Ʈũ ϴ Լ		*/
void FindStrike(int* pPN, int* pRD, int* pStrike, int Len);

/*	 ϴ Լ	*/
void FindBall(int* pPN, int* pRD, int* pBall, int Len);

int main(void)
{
	srand((unsigned)time(NULL));

	int User_Selection = 0;				//	 ޴ 
	int EXIT = OFF;						//	 ݺ  
	int Random_Num[MAX_NUM];			//	ǻͰ ߻ ų   迭
	int User_Input[MAX_NUM] = { 0, };	//	ڰ Է  迭

	while (EXIT)
	{
		MENU();
		User_Selection_Menu(&User_Selection);

		switch (User_Selection)
		{
		case 1:
		{
			Generate_RandomNumber(Random_Num);
			ShowArrayNumber(Random_Num);
			break;
		}
		case 2:
		{
			Player_Input_Number(User_Input);
			ShowArrayNumber(User_Input);
			Play_Game(User_Input, Random_Num);
			break;
		}
		case 3:
		{
			LoadScore();
			break;
		}
		case 4:
		{
			EXIT = ON;
			break;
		}
		}
	}
	return 0;
}

/*	޴ ִ Լ	*/
void MENU(void)
{
	printf("ھ߱\n");
	printf("1. ȣ\n");
	printf("2. ӽ\n");
	printf("3. \n");
	printf("4. .\n");
}

/*	κ ޴  ޴ Լ	*/
void User_Selection_Menu(int* pUser)
{
	printf("=>  ");
	scanf("%d", pUser);
}

/*	ߺ  ʰ, 迭  ڸ ϴ Լ		*/
void Generate_RandomNumber(int* pRandom)
{
	int i = 0;			//	迭   
	int Len = MAX_NUM;	//	迭 ä  
	int count;			//	ߺ üũ , üũ 迭 ε
	int Overlaped;		//	ߺ üũϴ 
	int temp;			//	 

	//	迭 ͸  ä  ݺ
	while (i < Len)
	{
		Overlaped = NO;
		temp = rand() % NINE + 1;	//	1 ~ 9  Ѵ.

		//	迭 ε ŽѴ. 
		for (count = 0; count < i; count++)
		{
			//	ߺ 
			if (temp == *(pRandom + count))
			{
				Overlaped = YES;
				break;
			}
		}

		//	ߺ ƴϸ, ش ġ   Ѵ.
		if (Overlaped == NO)
		{
			*(pRandom + i) = temp;
			i++;
		}
	}
}

/*	 迭 ڸ ϴ Լ	*/
void ShowArrayNumber(int* pArray)
{
	int i;				
	int Len = MAX_NUM;
	for (i = 0; i < Len; i++)
	{
		printf("%d  ", *(pArray + i));
	}
	printf("\n");
}

/*	ߺ  ʰ, 迭 ڸ κ Է¹޾ ϴ Լ		*/
void Player_Input_Number(int* pPlayer_Num)
{
	int Len = MAX_NUM;	//	迭 ä  
	int i = 0;			//	迭   
	int Overlaped;		//	ߺ üũϴ 
	int count;			//	ߺ üũ , üũ 迭 ε
	int temp;			//	κ Է¹ 

	printf(" 3 Էϼ.\n");

	//	迭 ͸  ä  ݺ
	while (i < Len)
	{
		Overlaped = NO;
		printf("<%d°>  : ", i + 1);
		scanf("%d", &temp);

		if (temp < 1 || temp > 9)
		{
			printf("ڴ 1 10  Է մϴ. Է :  ");
			continue;
		}

		for (count = 0; count < i; count++)
		{
			if (temp == *(pPlayer_Num + count))
			{
				printf("ߺ̹Ƿ, Է : ");
				Overlaped = YES;
				break;
			}
		}

		if (Overlaped == NO)
		{
			*(pPlayer_Num + i) = temp;
			i++;
		}
	}
}

/*	  Լ	*/
void Play_Game(int* pPlayer_Num, int* pRandom)
{
	int TryCnt = 0;		//	  ȸ
	int Len = MAX_NUM;	//	迭 
	int Strike = 0;		//	Ʈũ ȸ
	int Ball = 0;		//	 ȸ

	//	3 Ʈũ   ݺ
	while (Strike != MAX_NUM)
	{
		TryCnt += 1;
		Strike = 0;
		Ball = 0;

		if (TryCnt == 1)
		{
			printf("%d° Ƚ\n", TryCnt);
			FindStrike(pPlayer_Num, pRandom, &Strike, Len);
			FindBall(pPlayer_Num, pRandom, &Ball, Len);
		}
		else if (TryCnt != 1)
		{
			printf("%d° Ƚ\n", TryCnt);
			Player_Input_Number(pPlayer_Num);		//	÷̾κ ٽ Է ޴´.
			FindStrike(pPlayer_Num, pRandom, &Strike, Len);
			FindBall(pPlayer_Num, pRandom, &Ball, Len);
		}
	}
	printf("ȣ ߱    %dԴϴ.\n", TryCnt);
	WriteScore(TryCnt);			//	õ ȸ  ̴.
}

/*	Ʈũ ϴ Լ		*/
void FindStrike(int* pPN, int* pRD, int* pStrike, int Len)
{
	int i;

	//	Ʈũ   ڸ   ġؾ Ѵ.
	for (i = 0; i < Len; i++)
	{
		if (*(pPN + i) == *(pRD + i))
			(*pStrike) += 1;
	}
	printf("%d Ʈũ.\n", *pStrike);
}

/*	 ϴ Լ	*/
void FindBall(int* pPN, int* pRD, int* pBall, int Len)
{
	int i;
	int j;

	//	  Ʈũ  ݴ̴.
	//	 ġ(ε)  ٸ,   ġϸ ȴ.
	for (i = 0; i < Len; i++)
	{
		for (j = 0; j < Len; j++)
		{
			if ((*(pPN + i) == *(pRD + j)) && (i != j))
				(*pBall) += 1;
		}
	}
	printf("%d .\n", *pBall);
}

